Index: NEMO/branches/2021/dev_r14273_HPC-02_Daley_Tiling/src/OCE/ZDF/zdfmfc.F90
===================================================================
--- NEMO/branches/2021/dev_r14273_HPC-02_Daley_Tiling/src/OCE/ZDF/zdfmfc.F90	(revision 14664)
+++ NEMO/branches/2021/dev_r14273_HPC-02_Daley_Tiling/src/OCE/ZDF/zdfmfc.F90	(revision 14665)
@@ -96,24 +96,24 @@
       INTEGER                                  , INTENT(in)    :: Kmm, Krhs ! time level indices
       REAL(wp), DIMENSION(jpi,jpj,jpk,jpts,jpt), INTENT(inout) :: pts       ! active tracers and RHS of tracer equation
-      REAL(wp), DIMENSION(jpi,jpj,jpk,2) ::   ztsp         ! T/S of the plume
-      REAL(wp), DIMENSION(jpi,jpj,jpk,2) ::   ztse         ! T/S at W point
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zrwp          !
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zrwp2         !
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zapp          !
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zedmf         !
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zepsT, zepsW  !
-      !
-      REAL(wp), DIMENSION(jpi,jpj) :: zustar, zustar2   !
-      REAL(wp), DIMENSION(jpi,jpj) :: zuws, zvws, zsws, zfnet          !
-      REAL(wp), DIMENSION(jpi,jpj) :: zfbuo, zrautbm1, zrautb, zraupl
-      REAL(wp), DIMENSION(jpi,jpj) :: zwpsurf            !
-      REAL(wp), DIMENSION(jpi,jpj) :: zop0 , zsp0 !
-      REAL(wp), DIMENSION(jpi,jpj) :: zrwp_0, zrwp2_0  !
-      REAL(wp), DIMENSION(jpi,jpj) :: zapp0           !
-      REAL(wp), DIMENSION(jpi,jpj) :: zphp, zph, zphpm1, zphm1, zNHydro
-      REAL(wp), DIMENSION(jpi,jpj) :: zhcmo          !
-      !
-      REAL(wp), DIMENSION(jpi,jpj,jpk)   ::   zn2    ! N^2
-      REAL(wp), DIMENSION(jpi,jpj,2  ) ::   zab, zabm1, zabp ! alpha and beta
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk,2) ::   ztsp         ! T/S of the plume
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk,2) ::   ztse         ! T/S at W point
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk) :: zrwp          !
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk) :: zrwp2         !
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk) :: zapp          !
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk) :: zedmf         !
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk) :: zepsT, zepsW  !
+      !
+      REAL(wp), DIMENSION(A2D(nn_hls)) :: zustar, zustar2   !
+      REAL(wp), DIMENSION(A2D(nn_hls)) :: zuws, zvws, zsws, zfnet          !
+      REAL(wp), DIMENSION(A2D(nn_hls)) :: zfbuo, zrautbm1, zrautb, zraupl
+      REAL(wp), DIMENSION(A2D(nn_hls)) :: zwpsurf            !
+      REAL(wp), DIMENSION(A2D(nn_hls)) :: zop0 , zsp0 !
+      REAL(wp), DIMENSION(A2D(nn_hls)) :: zrwp_0, zrwp2_0  !
+      REAL(wp), DIMENSION(A2D(nn_hls)) :: zapp0           !
+      REAL(wp), DIMENSION(A2D(nn_hls)) :: zphp, zph, zphpm1, zphm1, zNHydro
+      REAL(wp), DIMENSION(A2D(nn_hls)) :: zhcmo          !
+      !
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk)   ::   zn2    ! N^2
+      REAL(wp), DIMENSION(A2D(nn_hls),2  ) ::   zab, zabm1, zabp ! alpha and beta
      
       REAL(wp), PARAMETER :: zepsilon = 1.e-30                 ! local small value
@@ -136,35 +136,37 @@
       zcd          = 1._wp
 
-      !------------------------------------------------------------------
-      ! Surface boundary condition
-      !------------------------------------------------------------------
-      ! surface Stress
-      !--------------------
-      zuws(:,:) = utau(:,:) * r1_rho0 
-      zvws(:,:) = vtau(:,:) * r1_rho0 
-      zustar2(:,:) = SQRT(zuws(:,:)*zuws(:,:)+zvws(:,:)*zvws(:,:))
-      zustar(:,:)  = SQRT(zustar2(:,:))
-
-      ! Heat Flux
-      !--------------------
-      zfnet(:,:) = qns(:,:) + qsr(:,:)
-      zfnet(:,:) = zfnet(:,:) / (rho0 * rcp)
-
-      ! Water Flux
-      !---------------------
-      zsws(:,:) = emp(:,:)
-
-      !-------------------------------------------
-      ! Initialisation of prognostic variables
-      !-------------------------------------------
-      zrwp (:,:,:) =  0._wp ; zrwp2(:,:,:) =  0._wp ; zedmf(:,:,:) =  0._wp
-      zph  (:,:)   =  0._wp ; zphm1(:,:)   =  0._wp ; zphpm1(:,:)  =  0._wp
-      ztsp(:,:,:,:)=  0._wp
-
-      ! Tracers inside plume (ztsp) and environment (ztse)
-      ztsp(:,:,1,jp_tem) = pts(:,:,1,jp_tem,Kmm) * tmask(:,:,1)
-      ztsp(:,:,1,jp_sal) = pts(:,:,1,jp_sal,Kmm) * tmask(:,:,1)
-      ztse(:,:,1,jp_tem) = pts(:,:,1,jp_tem,Kmm) * tmask(:,:,1)
-      ztse(:,:,1,jp_sal) = pts(:,:,1,jp_sal,Kmm) * tmask(:,:,1)
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
+         !------------------------------------------------------------------
+         ! Surface boundary condition
+         !------------------------------------------------------------------
+         ! surface Stress
+         !--------------------
+         zuws(ji,jj) = utau(ji,jj) * r1_rho0
+         zvws(ji,jj) = vtau(ji,jj) * r1_rho0
+         zustar2(ji,jj) = SQRT(zuws(ji,jj)*zuws(ji,jj)+zvws(ji,jj)*zvws(ji,jj))
+         zustar(ji,jj)  = SQRT(zustar2(ji,jj))
+
+         ! Heat Flux
+         !--------------------
+         zfnet(ji,jj) = qns(ji,jj) + qsr(ji,jj)
+         zfnet(ji,jj) = zfnet(ji,jj) / (rho0 * rcp)
+
+         ! Water Flux
+         !---------------------
+         zsws(ji,jj) = emp(ji,jj)
+
+         !-------------------------------------------
+         ! Initialisation of prognostic variables
+         !-------------------------------------------
+         zrwp (ji,jj,:) =  0._wp ; zrwp2(ji,jj,:) =  0._wp ; zedmf(ji,jj,:) =  0._wp
+         zph  (ji,jj)   =  0._wp ; zphm1(ji,jj)   =  0._wp ; zphpm1(ji,jj)  =  0._wp
+         ztsp(ji,jj,:,:)=  0._wp
+
+         ! Tracers inside plume (ztsp) and environment (ztse)
+         ztsp(ji,jj,1,jp_tem) = pts(ji,jj,1,jp_tem,Kmm) * tmask(ji,jj,1)
+         ztsp(ji,jj,1,jp_sal) = pts(ji,jj,1,jp_sal,Kmm) * tmask(ji,jj,1)
+         ztse(ji,jj,1,jp_tem) = pts(ji,jj,1,jp_tem,Kmm) * tmask(ji,jj,1)
+         ztse(ji,jj,1,jp_sal) = pts(ji,jj,1,jp_sal,Kmm) * tmask(ji,jj,1)
+      END_2D
 
       CALL eos( ztse(:,:,1,:) ,  zrautb(:,:) )
@@ -174,8 +176,10 @@
       ! Boundary Condition of Mass Flux (plume velo.; convective area, entrain/detrain)
       !-------------------------------------------
-      zhcmo(:,:) = e3t(:,:,1,Kmm)
+      zhcmo(:,:) = e3t(A1Di(nn_hls),A1Dj(nn_hls),1,Kmm)
       zfbuo(:,:)   = 0._wp
       WHERE ( ABS(zrautb(:,:)) > 1.e-20 ) zfbuo(:,:)   =   &
-         &      grav * ( 2.e-4_wp *zfnet(:,:) - 7.6E-4_wp*pts(:,:,1,jp_sal,Kmm)*zsws(:,:)/zrautb(:,:)) * zhcmo(:,:)
+         &      grav * ( 2.e-4_wp *zfnet(:,:)              &
+         &      - 7.6E-4_wp*pts(A2D(nn_hls),1,jp_sal,Kmm)  &
+         &      * zsws(:,:)/zrautb(:,:)) * zhcmo(:,:)
 
       zedmf(:,:,1) = -0.065_wp*(ABS(zfbuo(:,:)))**(1._wp/3._wp)*SIGN(1.,zfbuo(:,:))
@@ -211,13 +215,14 @@
          CALL eos( ztsp(:,:,jk-1,:    ) ,  zraupl(:,:)   )
 
-         zphm1(:,:)  = zphm1(:,:)  + grav * zrautbm1(:,:) * e3t(:,:,jk-1, Kmm)
-         zphpm1(:,:) = zphpm1(:,:) + grav * zraupl(:,:)   * e3t(:,:,jk-1, Kmm)
-         zph(:,:)    = zphm1(:,:)  + grav * zrautb(:,:)   * e3t(:,:,jk  , Kmm)
-         zph(:,:)    = MAX( zph(:,:), zepsilon)
+         DO_2D( 0, 0, 0, 0 )
+            zphm1(ji,jj)  = zphm1(ji,jj)  + grav * zrautbm1(ji,jj) * e3t(ji,jj,jk-1, Kmm)
+            zphpm1(ji,jj) = zphpm1(ji,jj) + grav * zraupl(ji,jj)   * e3t(ji,jj,jk-1, Kmm)
+            zph(ji,jj)    = zphm1(ji,jj)  + grav * zrautb(ji,jj)   * e3t(ji,jj,jk  , Kmm)
+            zph(ji,jj)    = MAX( zph(ji,jj), zepsilon)
+         END_2D
 
          WHERE(zrautbm1 .NE. 0.) zfbuo(:,:)  =  grav * (zraupl(:,:) - zrautbm1(:,:)) / zrautbm1(:,:)
 
-         ! [comm_cleanup] ! DO_2D( 0, 0, 0, 0 )
-         DO_2D( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         DO_2D( 0, 0, 0, 0 )
 
             ! Compute Environment of Plume. Interpolation T/S (before time step) on W-points
@@ -323,8 +328,10 @@
 
       ! Compute Mass Flux on T-point
-      DO jk=1,jpk-1
-         edmfm(:,:,jk) = (zedmf(:,:,jk+1)  + zedmf(:,:,jk) )*0.5_wp
-      END DO
-      edmfm(:,:,jpk) = zedmf(:,:,jpk) 
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
+         edmfm(ji,jj,jk) = (zedmf(ji,jj,jk+1)  + zedmf(ji,jj,jk) )*0.5_wp
+      END_3D
+      DO_2D( 0, 0, 0, 0 )
+         edmfm(ji,jj,jpk) = zedmf(ji,jj,jpk)
+      END_2D
 
       ! Save variable (on T point)
@@ -339,44 +346,48 @@
       !  Computation of a tridiagonal matrix and right hand side terms of the linear system
       !=================================================================================
-      edmfa(:,:,:)     = 0._wp
-      edmfb(:,:,:)     = 0._wp
-      edmfc(:,:,:)     = 0._wp
-      edmftra(:,:,:,:) = 0._wp
+      DO_3D( 0, 0, 0, 0, 1, jpk )
+         edmfa(ji,jj,jk)     = 0._wp
+         edmfb(ji,jj,jk)     = 0._wp
+         edmfc(ji,jj,jk)     = 0._wp
+         edmftra(ji,jj,jk,:) = 0._wp
+      END_3D
 
       !---------------------------------------------------------------
       ! Diagonal terms 
       !---------------------------------------------------------------
-      DO jk=1,jpk-1
-         edmfa(:,:,jk) =  0._wp
-         edmfb(:,:,jk) = -edmfm(:,:,jk  ) / e3w(:,:,jk+1,Kmm)
-         edmfc(:,:,jk) =  edmfm(:,:,jk+1) / e3w(:,:,jk+1,Kmm)
-      END DO
-      edmfa(:,:,jpk)   = -edmfm(:,:,jpk-1) / e3w(:,:,jpk,Kmm)
-      edmfb(:,:,jpk)   =  edmfm(:,:,jpk  ) / e3w(:,:,jpk,Kmm)
-      edmfc(:,:,jpk)   =  0._wp
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
+         edmfa(ji,jj,jk) =  0._wp
+         edmfb(ji,jj,jk) = -edmfm(ji,jj,jk  ) / e3w(ji,jj,jk+1,Kmm)
+         edmfc(ji,jj,jk) =  edmfm(ji,jj,jk+1) / e3w(ji,jj,jk+1,Kmm)
+      END_3D
+      DO_2D( 0, 0, 0, 0 )
+         edmfa(ji,jj,jpk)   = -edmfm(ji,jj,jpk-1) / e3w(ji,jj,jpk,Kmm)
+         edmfb(ji,jj,jpk)   =  edmfm(ji,jj,jpk  ) / e3w(ji,jj,jpk,Kmm)
+         edmfc(ji,jj,jpk)   =  0._wp
+      END_2D
 
       !---------------------------------------------------------------
       ! right hand side term for Temperature
       !---------------------------------------------------------------
-      DO jk=1,jpk-1
-        edmftra(:,:,jk,1) = - edmfm(:,:,jk  ) * ztsp(:,:,jk  ,jp_tem) / e3w(:,:,jk+1,Kmm) &
-                          & + edmfm(:,:,jk+1) * ztsp(:,:,jk+1,jp_tem) / e3w(:,:,jk+1,Kmm)
-      END DO
-      edmftra(:,:,jpk,1) = - edmfm(:,:,jpk-1) * ztsp(:,:,jpk-1,jp_tem) / e3w(:,:,jpk,Kmm) &
-                         & + edmfm(:,:,jpk  ) * ztsp(:,:,jpk  ,jp_tem) / e3w(:,:,jpk,Kmm)
-                        
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
+        edmftra(ji,jj,jk,1) = - edmfm(ji,jj,jk  ) * ztsp(ji,jj,jk  ,jp_tem) / e3w(ji,jj,jk+1,Kmm) &
+                            & + edmfm(ji,jj,jk+1) * ztsp(ji,jj,jk+1,jp_tem) / e3w(ji,jj,jk+1,Kmm)
+      END_3D
+      DO_2D( 0, 0, 0, 0 )
+         edmftra(ji,jj,jpk,1) = - edmfm(ji,jj,jpk-1) * ztsp(ji,jj,jpk-1,jp_tem) / e3w(ji,jj,jpk,Kmm) &
+                              & + edmfm(ji,jj,jpk  ) * ztsp(ji,jj,jpk  ,jp_tem) / e3w(ji,jj,jpk,Kmm)
+      END_2D
+
       !---------------------------------------------------------------
       ! Right hand side term for Salinity
       !---------------------------------------------------------------
-      DO jk=1,jpk-1
-         edmftra(:,:,jk,2) =  - edmfm(:,:,jk  ) * ztsp(:,:,jk  ,jp_sal) / e3w(:,:,jk+1,Kmm) &
-                           &  + edmfm(:,:,jk+1) * ztsp(:,:,jk+1,jp_sal) / e3w(:,:,jk+1,Kmm)
-      END DO
-      edmftra(:,:,jpk,2) = - edmfm(:,:,jpk-1) * ztsp(:,:,jpk-1,jp_sal) / e3w(:,:,jpk,Kmm) &
-                         & + edmfm(:,:,jpk  ) * ztsp(:,:,jpk  ,jp_sal) / e3w(:,:,jpk,Kmm)
-      !
-      !
-      ! [comm_cleanup] 
-      IF (nn_hls.eq.1) CALL lbc_lnk( 'zdfmfc', edmfm,'T',1., edmfa,'T',1., edmfb,'T',1., edmfc,'T',1., edmftra(:,:,:,jp_tem),'T',1., edmftra(:,:,:,jp_sal),'T',1.)
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
+         edmftra(ji,jj,jk,2) =  - edmfm(ji,jj,jk  ) * ztsp(ji,jj,jk  ,jp_sal) / e3w(ji,jj,jk+1,Kmm) &
+                             &  + edmfm(ji,jj,jk+1) * ztsp(ji,jj,jk+1,jp_sal) / e3w(ji,jj,jk+1,Kmm)
+      END_3D
+      DO_2D( 0, 0, 0, 0 )
+         edmftra(ji,jj,jpk,2) = - edmfm(ji,jj,jpk-1) * ztsp(ji,jj,jpk-1,jp_sal) / e3w(ji,jj,jpk,Kmm) &
+                              & + edmfm(ji,jj,jpk  ) * ztsp(ji,jj,jpk  ,jp_sal) / e3w(ji,jj,jpk,Kmm)
+      END_2D
       !
    END SUBROUTINE tra_mfc
@@ -385,7 +396,7 @@
    SUBROUTINE diag_mfc( zdiagi, zdiagd, zdiags, p2dt, Kaa )
 
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::  zdiagi, zdiagd, zdiags  ! inout: tridaig. terms 
-      REAL(wp)                        , INTENT(in   ) ::   p2dt                   ! tracer time-step
-      INTEGER                         , INTENT(in   ) ::   Kaa                    ! ocean time level indices
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk), INTENT(inout) ::  zdiagi, zdiagd, zdiags  ! inout: tridaig. terms
+      REAL(wp)                            , INTENT(in   ) ::   p2dt                   ! tracer time-step
+      INTEGER                             , INTENT(in   ) ::   Kaa                    ! ocean time level indices
 
       INTEGER  ::   ji, jj, jk  ! dummy  loop arguments   
Index: NEMO/branches/2021/dev_r14273_HPC-02_Daley_Tiling/src/OCE/ZDF/zdfmxl.F90
===================================================================
--- NEMO/branches/2021/dev_r14273_HPC-02_Daley_Tiling/src/OCE/ZDF/zdfmxl.F90	(revision 14664)
+++ NEMO/branches/2021/dev_r14273_HPC-02_Daley_Tiling/src/OCE/ZDF/zdfmxl.F90	(revision 14665)
@@ -26,5 +26,5 @@
    PRIVATE
 
-   PUBLIC   zdf_mxl   ! called by zdfphy.F90
+   PUBLIC   zdf_mxl, zdf_mxl_turb   ! called by zdfphy.F90
 
    INTEGER , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   nmln    !: number of level in the mixed layer (used by LDF, ZDF, TRD, TOP)
@@ -65,16 +65,11 @@
       !!                  ***  ROUTINE zdfmxl  ***
       !!                   
-      !! ** Purpose :   Compute the turbocline depth and the mixed layer depth
-      !!              with density criteria.
+      !! ** Purpose :   Compute the mixed layer depth with density criteria.
       !!
       !! ** Method  :   The mixed layer depth is the shallowest W depth with 
       !!      the density of the corresponding T point (just bellow) bellow a
       !!      given value defined locally as rho(10m) + rho_c
-      !!               The turbocline depth is the depth at which the vertical
-      !!      eddy diffusivity coefficient (resulting from the vertical physics
-      !!      alone, not the isopycnal part, see trazdf.F) fall below a given
-      !!      value defined locally (avt_c here taken equal to 5 cm/s2 by default)
       !!
-      !! ** Action  :   nmln, hmld, hmlp, hmlpt
+      !! ** Action  :   nmln, hmlp, hmlpt
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
@@ -82,23 +77,26 @@
       !
       INTEGER  ::   ji, jj, jk      ! dummy loop indices
-      INTEGER  ::   iikn, iiki, ikt ! local integer
+      INTEGER  ::   iik, ikt        ! local integer
       REAL(wp) ::   zN2_c           ! local scalar
-      INTEGER, DIMENSION(jpi,jpj) ::   imld   ! 2D workspace
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'zdf_mxl : mixed layer depth'
-         IF(lwp) WRITE(numout,*) '~~~~~~~ '
-         !                             ! allocate zdfmxl arrays
-         IF( zdf_mxl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_mxl : unable to allocate arrays' )
+      IF( .NOT. l_istiled .OR. ntile == 1 )  THEN                       ! Do only on the first tile
+         IF( kt == nit000 ) THEN
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) 'zdf_mxl : mixed layer depth'
+            IF(lwp) WRITE(numout,*) '~~~~~~~ '
+            !                             ! allocate zdfmxl arrays
+            IF( zdf_mxl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_mxl : unable to allocate arrays' )
+         ENDIF
       ENDIF
       !
       ! w-level of the mixing and mixed layers
-      nmln(:,:)  = nlb10                  ! Initialization to the number of w ocean point
-      hmlp(:,:)  = 0._wp                  ! here hmlp used as a dummy variable, integrating vertically N^2
+      DO_2D_OVR( nn_hls, nn_hls, nn_hls, nn_hls )
+         nmln(ji,jj)  = nlb10                  ! Initialization to the number of w ocean point
+         hmlp(ji,jj)  = 0._wp                  ! here hmlp used as a dummy variable, integrating vertically N^2
+      END_2D
       zN2_c = grav * rho_c * r1_rho0      ! convert density criteria into N^2 criteria
       ! [comm_cleanup] ! DO_3D( 1, 1, 1, 1, nlb10, jpkm1 )   ! Mixed layer level: w-level
-      DO_3D( nn_hls, nn_hls, nn_hls, nn_hls, nlb10, jpkm1 )   ! Mixed layer level: w-level
+      DO_3D_OVR( nn_hls, nn_hls, nn_hls, nn_hls, nlb10, jpkm1 )   ! Mixed layer level: w-level
          ikt = mbkt(ji,jj)
          hmlp(ji,jj) =   &
@@ -106,32 +104,16 @@
          IF( hmlp(ji,jj) < zN2_c )   nmln(ji,jj) = MIN( jk , ikt ) + 1   ! Mixed layer level
       END_3D
-      !
-      ! w-level of the turbocline and mixing layer (iom_use)
-      imld(:,:) = mbkt(:,:) + 1                ! Initialization to the number of w ocean point
-      ! [comm_cleanup] ! DO_3DS( 1, 1, 1, 1, jpkm1, nlb10, -1 )   ! from the bottom to nlb10
-      DO_3DS( nn_hls, nn_hls, nn_hls, nn_hls, jpkm1, nlb10, -1 )   ! from the bottom to nlb10
-         IF( avt (ji,jj,jk) < avt_c * wmask(ji,jj,jk) )   imld(ji,jj) = jk      ! Turbocline 
-      END_3D
-      ! depth of the mixing and mixed layers
+      ! depth of the mixed layer
       ! [comm_cleanup] ! DO_2D( 1, 1, 1, 1 )
-      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
-         iiki = imld(ji,jj)
-         iikn = nmln(ji,jj)
-         hmld (ji,jj) = gdepw(ji,jj,iiki  ,Kmm) * ssmask(ji,jj)    ! Turbocline depth 
-         hmlp (ji,jj) = gdepw(ji,jj,iikn  ,Kmm) * ssmask(ji,jj)    ! Mixed layer depth
-         hmlpt(ji,jj) = gdept(ji,jj,iikn-1,Kmm) * ssmask(ji,jj)    ! depth of the last T-point inside the mixed layer
+      DO_2D_OVR( nn_hls, nn_hls, nn_hls, nn_hls )
+         iik = nmln(ji,jj)
+         hmlp (ji,jj) = gdepw(ji,jj,iik  ,Kmm) * ssmask(ji,jj)    ! Mixed layer depth
+         hmlpt(ji,jj) = gdept(ji,jj,iik-1,Kmm) * ssmask(ji,jj)    ! depth of the last T-point inside the mixed layer
       END_2D
       !
-      IF( .NOT.l_offline ) THEN
-         IF( iom_use("mldr10_1") ) THEN
-            IF( ln_isfcav ) THEN  ;  CALL iom_put( "mldr10_1", hmlp - risfdep)   ! mixed layer thickness
-            ELSE                  ;  CALL iom_put( "mldr10_1", hmlp )            ! mixed layer depth
-            END IF
+      IF( .NOT.l_offline .AND. iom_use("mldr10_1") ) THEN
+         IF( ln_isfcav ) THEN  ;  CALL iom_put( "mldr10_1", hmlp - risfdep)   ! mixed layer thickness
+         ELSE                  ;  CALL iom_put( "mldr10_1", hmlp )            ! mixed layer depth
          END IF
-         IF( iom_use("mldkz5") ) THEN
-            IF( ln_isfcav ) THEN  ;  CALL iom_put( "mldkz5"  , hmld - risfdep )   ! turbocline thickness
-            ELSE                  ;  CALL iom_put( "mldkz5"  , hmld )             ! turbocline depth
-            END IF
-         ENDIF
       ENDIF
       !
@@ -140,4 +122,44 @@
    END SUBROUTINE zdf_mxl
 
+
+   SUBROUTINE zdf_mxl_turb( kt, Kmm )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE zdf_mxl_turb  ***
+      !!
+      !! ** Purpose :   Compute the turbocline depth.
+      !!
+      !! ** Method  :   The turbocline depth is the depth at which the vertical
+      !!      eddy diffusivity coefficient (resulting from the vertical physics
+      !!      alone, not the isopycnal part, see trazdf.F) fall below a given
+      !!      value defined locally (avt_c here taken equal to 5 cm/s2 by default)
+      !!
+      !! ** Action  :   hmld
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      INTEGER, INTENT(in) ::   Kmm  ! ocean time level index
+      !
+      INTEGER  ::   ji, jj, jk      ! dummy loop indices
+      INTEGER  ::   iik             ! local integer
+      INTEGER, DIMENSION(A2D(nn_hls)) ::   imld   ! 2D workspace
+      !!----------------------------------------------------------------------
+      !
+      ! w-level of the turbocline and mixing layer (iom_use)
+      imld(:,:) = mbkt(A2D(nn_hls)) + 1                ! Initialization to the number of w ocean point
+      DO_3DS( 0, 0, 0, 0, jpkm1, nlb10, -1 )   ! from the bottom to nlb10
+         IF( avt (ji,jj,jk) < avt_c * wmask(ji,jj,jk) )   imld(ji,jj) = jk      ! Turbocline
+      END_3D
+      ! depth of the mixing layer
+      DO_2D( 0, 0, 0, 0 )
+         iik = imld(ji,jj)
+         hmld (ji,jj) = gdepw(ji,jj,iik  ,Kmm) * ssmask(ji,jj)    ! Turbocline depth
+      END_2D
+      !
+      IF( .NOT.l_offline .AND. iom_use("mldkz5") ) THEN
+         IF( ln_isfcav ) THEN  ;  CALL iom_put( "mldkz5"  , hmld - risfdep )   ! turbocline thickness
+         ELSE                  ;  CALL iom_put( "mldkz5"  , hmld )             ! turbocline depth
+         END IF
+      ENDIF
+      !
+   END SUBROUTINE zdf_mxl_turb
    !!======================================================================
 END MODULE zdfmxl
Index: NEMO/branches/2021/dev_r14273_HPC-02_Daley_Tiling/src/OCE/ZDF/zdfosm.F90
===================================================================
--- NEMO/branches/2021/dev_r14273_HPC-02_Daley_Tiling/src/OCE/ZDF/zdfosm.F90	(revision 14664)
+++ NEMO/branches/2021/dev_r14273_HPC-02_Daley_Tiling/src/OCE/ZDF/zdfosm.F90	(revision 14665)
@@ -1214,5 +1214,6 @@
         ! Lateral boundary conditions on final outputs for hbl,  on T-grid (sign unchanged)
         ! [comm_cleanup] ! no need lbc_lnk for output
-        ! CALL lbc_lnk( 'zdfosm', hbl, 'T', 1., dh, 'T', 1., hmle, 'T', 1. )
+        ! NOTE: [tiling] still needed (at least for hmle in tra_mle_trp)
+         CALL lbc_lnk( 'zdfosm', hbl, 'T', 1., dh, 'T', 1., hmle, 'T', 1. )
         ! Lateral boundary conditions on final outputs for gham[ts],  on W-grid  (sign unchanged)
         ! Lateral boundary conditions on final outputs for gham[uv],  on [UV]-grid  (sign changed)
@@ -2874,5 +2875,5 @@
       !
       IF( kt == nit000 ) THEN
-         IF( ntile == 0 .OR. ntile == 1 ) THEN                    ! Do only on the first tile
+         IF( .NOT. l_istiled .OR. ntile == 1 ) THEN                    ! Do only on the first tile
             IF(lwp) WRITE(numout,*)
             IF(lwp) WRITE(numout,*) 'tra_osm : OSM non-local tracer fluxes'
@@ -2886,6 +2887,5 @@
       ENDIF
 
-      ! [comm_cleanup] ! DO_3D( 0, 0, 0, 0, 1, jpkm1 )
-      DO_3D( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
          pts(ji,jj,jk,jp_tem,Krhs) =  pts(ji,jj,jk,jp_tem,Krhs)                      &
             &                 - (  ghamt(ji,jj,jk  )  &
@@ -2948,12 +2948,13 @@
       !
       IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn_osm : OSM non-local velocity'
-         IF(lwp) WRITE(numout,*) '~~~~~~~   '
+         IF( .NOT. l_istiled .OR. ntile == 1 )  THEN                       ! Do only on the first tile
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) 'dyn_osm : OSM non-local velocity'
+            IF(lwp) WRITE(numout,*) '~~~~~~~   '
+         ENDIF
       ENDIF
       !code saving tracer trends removed, replace with trdmxl_oce
 
-      ! [comm_cleanup] ! DO_3D( 0, 0, 0, 0, 1, jpkm1 )       ! add non-local u and v fluxes
-      DO_3D( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 1, jpkm1 )       ! add non-local u and v fluxes
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )       ! add non-local u and v fluxes
          puu(ji,jj,jk,Krhs) =  puu(ji,jj,jk,Krhs)                      &
             &                 - (  ghamu(ji,jj,jk  )  &
